-- StorayUI
-- Thanks for helping out, this is my first addon



local frame = CreateFrame("Frame")
frame:RegisterEvent("ADDON_LOADED")



-- Frame texture coloring
frame:SetScript("OnEvent", function(self, event, addon)
        if (addon == "StorayUI") then
                for i, v in pairs({ ActionBarFrameTexture, PlayerFrameTexture, TargetFrameTextureFrameTexture, PetFrameTexture, PartyMemberFrame1Texture, PartyMemberFrame2Texture, PartyMemberFrame3Texture, PartyMemberFrame4Texture,
                        PartyMemberFrame1PetFrameTexture, PartyMemberFrame2PetFrameTexture, PartyMemberFrame3PetFrameTexture, PartyMemberFrame4PetFrameTexture, FocusFrameTextureFrameTexture,
                        TargetFrameToTTextureFrameTexture, FocusFrameToTTextureFrameTexture, FocusFrameSpellBarBorder, TargetFrameSpellBarBorder })
                do
                        v:SetVertexColor(0, 0, 0)
                end

				-- Remove text spam over unit frames
				PlayerHitIndicator:SetText(nil)
				PlayerHitIndicator.SetText = function() end
				PetHitIndicator:SetText(nil)
				PetHitIndicator.SetText = function() end

                self:UnregisterEvent("ADDON_LOADED")
                frame:SetScript("OnEvent", nil)
        end
end)



-- Class icons
hooksecurefunc("UnitFramePortrait_Update",function(self)
        if self.portrait then
                if UnitIsPlayer(self.unit) then                         
                        local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))]
                        if t then
                                self.portrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles")
                                self.portrait:SetTexCoord(unpack(t))
                        end
                else
                        self.portrait:SetTexCoord(0, 1, 0, 1)
                end
        end
end)



-- Bar coloring
local function colorBar(statusbar, unit)
        local _, class, c
        if UnitIsPlayer(unit) and UnitIsConnected(unit) and unit == statusbar.unit and UnitClass(unit) then
                _, class = UnitClass(unit)
                c = CUSTOM_CLASS_COLORS and CUSTOM_CLASS_COLORS[class] or RAID_CLASS_COLORS[class]
                statusbar:SetStatusBarColor(c.r, c.g, c.b)
                PlayerFrameHealthBar:SetStatusBarColor(0, 1, 0)
        end
end
-- Color bar when health bar update function is called
hooksecurefunc("UnitFrameHealthBar_Update", colorBar)
-- Color bar when unit health value updates
hooksecurefunc("HealthBar_OnValueChanged", function(self)
        colorBar(self, self.unit)
end)